part of tecfy_basic_package;

abstract class BaseModel {
  String get idValue;
  String get displayName;

  bool getBool(dynamic val) => BaseModel.getBoolEx(val);
  static bool getBoolEx(dynamic val) {
    if (val == null) return false;
    if (val is bool) return val;
    if (val is String) return val == 'true' || val == '1';
    if (val is num) return val == 1;
    return false;
  }

  DateTime? getDate(dynamic val) => BaseModel.getDateEx(val);
  static DateTime? getDateEx(dynamic val) {
    if (val == null) return null;
    if (val is DateTime) return val;
    if (val is String) return parseUTC(val);
    return null;
  }

  double? getDouble(dynamic val, [bool defaultIsZero = true]) =>
      BaseModel.getDoubleEx(val, defaultIsZero);
  static double? getDoubleEx(dynamic val, [bool defaultIsZero = true]) {
    if (val == null) return defaultIsZero ? 0 : null;
    if (val is num) return (val as num).toDouble();
    if (val is String)
      return double.tryParse(val) ?? (defaultIsZero ? 0 : null);
    return (defaultIsZero ? 0 : null);
  }

  static bool isDefault(String? id) => id != null && id.length < 30;
  // convert service time to DateTime UTC
  static DateTime? parseUTC(String? serverValue,
      {String format = "yyyy-MM-ddTHH:mm", DateTime? defaultValue}) {
    if (serverValue == null) return defaultValue;
    try {
      return intl.DateFormat(format).parseUTC(serverValue);
    } catch (err) {
      return defaultValue;
    }
  }
}
